#!/bin/bash

nodes="A B C D E F G H I J K L M N O P Q R S T U V W X Y Z"
map="a b c d e f g h i j k l m n o p q r s t u v w x y z"

echo "Content-type: text/html"
echo ""

fix_ltgt()
{
	sed "s/</\&lt;/g;s/>/\&gt;/g"
}

qs=`echo "$QUERY_STRING" | tr "&" "\n"`

for n in $qs
do
	exp="QS_$n"
	export $exp
done

export QS_expr=`echo "$QS_expr" | /home/igor2/C/libporty/trunk/src/porty/c99tree/url.sh`

if test -z "$QS_expr"
then
	export QS_expr='
# BFS search all leaf nodes
([] /* p=[]) && !(p . [])
'
fi

echo "<html>"
echo "<body>"
echo "<H1> gentrex test page </H1>"
echo '
On this page you can try out gentrex on a static tree. You are free to write
expressions to explore the tree and use the map, considering:
<ul>
	<li> nodes have three fields: <i>name</i>, <i>uid</i> and <i>user</i>
	<li> <i>name</i> is an uppercase letter between A and Z
	<li> <i>uid</i> is a number between 0 and 26, derived from name
	<li> <i>user</i> is an user-defined text field (empty by default)
	<li> there are 26 empty slots in the map, named with lowercase letters between a and z
	<li> it is possible to preload the map with tree nodes; such map=node statements specifies the initial map setup
	<li> the map is reset to the initial map setup
	<li> all matches are dumped in text form
	<li> the first match and a summary of all matches are also drawn using graphviz
	<li> there are limits on resources (e.g. CPU, memory) that may kill the request
</ul>'
echo "<P>"
echo "<table border=1 cellspacing=0 cellpadding=5>"
echo "<tr><th colspan=2> expression:"
echo "<tr><td colspan=2> <form action=\"/cgi-bin/gentrex.cgi\" method=get>"
echo "                   <textarea id=\"expr\" name=\"expr\" cols=80 rows=5>$QS_expr</textarea>"

echo "<tr><td>"

echo "<table border=0>"
echo "<tr><th colspan=2> user fields"
echo "<tr><td colspan=2> &nbsp;"
echo "<tr><th>node<th>text"
for f in $nodes
do
	tmp="\$QS_n_$f"
	tmp=`eval echo $tmp`
	echo "<tr><td>$f<td><input name=\"n_$f\" value=\"$tmp\">"
	if test ! -z "$tmp"
	then
		tmp=`echo $tmp | sed "s/[^a-zA-Z_0-9-]/_/g"`
		node_asg="$node_asg $f=$tmp"
	fi
done
echo "</table>"

echo "<td>"
echo "<table border=0>"
echo "<tr><th colspan=2> map nodes"
echo "<tr><td colspan=3> &nbsp;"
echo "<tr><th>map<th>node (A..Z)<th>print in result"
for f in $map
do
	tmp="\$QS_m_$f"
	tmp=`eval echo $tmp`
#	tmp=${tmp:0:1}
	echo "<tr><td>$f<td><input name=\"m_$f\" value=\"$tmp\" size=12><td>n/a"
	if test ! -z "$tmp"
	then
		map_asg="$map_asg $f=$tmp"
	fi
done
echo "</table>"

echo "</table>"
echo "<p>"
echo "<input type=\"submit\">"
echo "</form>"

QS_format=${QS_cmd##*_}
QS_cmd_=${QS_cmd%%_*}

echo "<p>"
echo "Expression:"
echo "<pre>"
echo "$QS_expr"
echo "</pre>"

ulimit -t 2
ulimit -d 2048
ulimit -s 2048
ulimit -v 32768

#echo "<pre>"
#ulimit -a
#echo "</pre>"

if test ! -z "$map_asg"
then
	map_asg=`echo "$map_asg" | sed "s/[^a-zA-Z=]//g"`
fi

if test ! -z "$QS_expr"
then
	tmp1=`tempfile`
	tmpA=`tempfile`

	echo "Bytecode dump and result:"
	echo "<pre>"

	echo "$QS_expr" | grep -v "^#" | /home/igor2/C/gentrex/trunk/src_regex/example_app -d -g $tmp1 -G $tmpA $node_asg $map_asg 2>&1
	echo "</pre>"

	echo "<hr>"
	echo "<p> First match:"
	echo "<p>"
	echo "<svg width=1500 height=700>"
	dot -Tsvg $tmp1
	echo "</svg>"
	echo '
<pre>
	Legend:
	Nodes have at most 3 lines:
		- name (mandatory)
		- user
		- list of map references
	square box means there are map items pointing to the node
	red means this node is the result of the expression
</pre>
'

	echo "<hr>"
	echo "<p> Summary of all matches:"
	echo "<p>"
	echo "<svg width=1500 height=700>"
	dot -Tsvg $tmpA
	echo "</svg>"

	echo '
<pre>
	Legend:
	Nodes have at most 4 lines:
		- name (mandatory)
		- user
		- list of map references as "mapname(number-of-references)"
		- the number of times the given node was the result of the expression
	square box means there were map items pointing to the node
	red means this node was the result of an expression
</pre>
'

	rm $tmp1 $tmpA
fi





echo "</body>"
echo "</html>"
